var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _class, _class2, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { observer } from 'mobx-react';
import withModalStore from '../../hocs/withModalStore';
import withIssuer from '../../hocs/withIssuer';
import { MODAL } from '../../utils/Issuers';
import ModalProvider from '../ModalProvider';

var ModalConsumer = (_dec = withIssuer({ issuer: MODAL }), _dec2 = withModalStore(), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 = function (_Component) {
	_inherits(ModalConsumer, _Component);

	function ModalConsumer(props) {
		_classCallCheck(this, ModalConsumer);

		var _this = _possibleConstructorReturn(this, (ModalConsumer.__proto__ || Object.getPrototypeOf(ModalConsumer)).call(this, props));

		_this.close = function () {
			_this.props.modalStore.close();
		};

		var children = props.children,
		    modalStore = props.modalStore,
		    other = _objectWithoutProperties(props, ['children', 'modalStore']);

		modalStore.setModalProps(other);
		return _this;
	}

	_createClass(ModalConsumer, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.props.modalStore.setModalProps({});
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    modalStore = _props.modalStore,
			    children = _props.children;

			return React.createElement(
				ModalProvider,
				{ modalStore: modalStore },
				children
			);
		}
	}]);

	return ModalConsumer;
}(Component), _class2.propTypes = {
	children: PropTypes.node,
	modalStore: PropTypes.object.isRequired
}, _temp)) || _class) || _class) || _class);
export { ModalConsumer as default };