import { style as _style } from 'antd/lib/message/style';
import _default from 'antd/lib/message';
import _isFunction from 'lodash/isFunction';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component } from 'react';
import { createRef } from '../../utils/reactPolyfill';
import PropTypes from '../../utils/PropTypes';
import { observer } from 'mobx-react';
import warning from 'warning';

import routerStore from '../../stores/routerStore';
import withTable from '../../hocs/withTable';
import withIssuer from '../../hocs/withIssuer';
import withStore from '../../hocs/withStore';
import { Submit } from '../../components/Form';
import FormBody from '../../components/FormBody';
import joinKeys from '../../utils/joinKeys';
import { CREATER } from '../../utils/Issuers';

import ModalProvider from '../../components/ModalProvider';

export default function createFormDetailView(title, issuer, displayName) {
	var _dec, _dec2, _dec3, _class, _class2, _temp, _initialiseProps;

	var isCreater = issuer === CREATER;

	var FormDetailView = (_dec = withIssuer({ issuer: issuer }), _dec2 = withTable({ syncLocation: true, type: 'detail' }), _dec3 = withStore(), _dec(_class = _dec2(_class = _dec3(_class = observer(_class = (_temp = _class2 = function (_Component) {
		_inherits(FormDetailView, _Component);

		function FormDetailView(props) {
			_classCallCheck(this, FormDetailView);

			var _this = _possibleConstructorReturn(this, (FormDetailView.__proto__ || Object.getPrototypeOf(FormDetailView)).call(this, props));

			_initialiseProps.call(_this);

			var store = props.store,
			    match = props.match;

			var selectedKeys = (match.params.key || '').split(',');
			if (isCreater) {
				_this._createrValue = {};
			} else {
				store.setSelectedKeys(selectedKeys);
				store.call('fetch');
			}
			return _this;
		}

		_createClass(FormDetailView, [{
			key: '_redirectToUpdate',
			value: function _redirectToUpdate(store, responseData) {
				var _routerStore$location = routerStore.location,
				    pathname = _routerStore$location.pathname,
				    search = _routerStore$location.search;
				var uniqueKey = store.config.uniqueKey;

				if (uniqueKey && responseData && responseData[uniqueKey]) {
					var key = responseData[uniqueKey];
					var newPathname = pathname.replace(/create$/, 'update/' + key);
					var path = newPathname + search;
					routerStore.replace(path);
				}
			}
		}, {
			key: 'render',
			value: function render() {
				var _props = this.props,
				    store = _props.store,
				    Header = _props.header,
				    Footer = _props.footer,
				    _state = this.state,
				    isValid = _state.isValid,
				    isSubmitting = _state.isSubmitting,
				    isPristine = _state.isPristine;

				return React.createElement(
					ModalProvider,
					null,
					React.createElement(
						'div',
						{ style: styles.container },
						Header ? React.createElement(Header, { title: title, store: store }) : React.createElement(
							'h1',
							null,
							title
						),
						React.createElement(FormBody, {
							ref: this.formRef,
							value: isCreater ? this._createrValue : store.getData(),
							store: store,
							onSubmit: this._handleSubmit,
							onChange: this._handleChange,
							onValidChange: this._handleValidChange,
							layout: 'vertical',
							footer: React.createElement(
								Submit,
								{
									disabled: isPristine || !isValid || isSubmitting,
									type: 'primary',
									size: 'large',
									loading: isSubmitting
								},
								'Save'
							)
						}),
						Footer && React.createElement(Footer, { store: store })
					)
				);
			}
		}]);

		return FormDetailView;
	}(Component), _class2.displayName = displayName, _class2.propTypes = {
		match: PropTypes.object.isRequired,
		store: PropTypes.object.isRequired,
		save: PropTypes.stringOrFunc,
		title: PropTypes.node,
		header: PropTypes.component,
		footer: PropTypes.component
	}, _class2.defaultProps = {
		title: title,
		save: isCreater ? 'create' : 'update'
	}, _initialiseProps = function _initialiseProps() {
		var _this2 = this;

		this.state = {
			isValid: true,
			isSubmitting: false,
			isPristine: true
		};
		this.formRef = createRef();

		this._handleChange = function () {
			if (_this2.state.isPristine) {
				_this2.setState({ isPristine: false });
			}
		};

		this._handleValidChange = function (isValid) {
			_this2.isValid = isValid;
			_this2.setState({ isValid: isValid });
		};

		this._handleSubmit = function () {
			var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(body) {
				var props, match, save, store, selectedKeys, url, reqParams, responseData;
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_this2.setState({ isSubmitting: true });
								props = _this2.props;
								match = props.match, save = props.save, store = props.store;
								selectedKeys = (match.params.key || '').split(',');
								url = joinKeys(selectedKeys);
								_context.prev = 5;
								reqParams = _extends({}, props, {
									url: url,
									body: body,
									refresh: false,
									throwError: true
								});

								if (!_isFunction(save)) {
									_context.next = 13;
									break;
								}

								_context.next = 10;
								return save(reqParams);

							case 10:
								_context.t0 = _context.sent;
								_context.next = 16;
								break;

							case 13:
								_context.next = 15;
								return store.call(save, reqParams);

							case 15:
								_context.t0 = _context.sent;

							case 16:
								responseData = _context.t0;

								_this2.setState({ isSubmitting: false, isPristine: true });

								// TODO: should add locale support
								_default.info('Success!');

								if (isCreater) {
									_this2._redirectToUpdate(store, responseData);
								}
								_context.next = 27;
								break;

							case 22:
								_context.prev = 22;
								_context.t1 = _context['catch'](5);

								_this2.setState({ isSubmitting: false });
								_default.error('Failed!');
								process.env.NODE_ENV !== 'production' ? warning(false, _context.t1.message) : void 0;

							case 27:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, _this2, [[5, 22]]);
			}));

			return function (_x) {
				return _ref.apply(this, arguments);
			};
		}();
	}, _temp)) || _class) || _class) || _class) || _class);


	return FormDetailView;
}