import _isFunction from 'lodash/isFunction';
import _isObject from 'lodash/isObject';
import _isString from 'lodash/isString';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import PropTypes from 'prop-types';
import { DatePicker } from '../../components/Form';
import field from '../../hocs/field';
import moment from 'moment';


var buildInDefaultProps = {
	inputFilter: function inputFilter(val) {
		if (!val) {} else if (_isObject(val)) {
			return val;
		} else if (_isString(val)) {
			return moment(val);
		}
	},
	outputFilter: function outputFilter(val) {
		if (!val) {} else if (_isFunction(val.toISOString)) {
			return val.toISOString();
		} else if (_isString(val)) {
			return val;
		}
	}
};

function DatePickerField(props) {
	return React.createElement(DatePicker, _extends({
		format: 'date',
		defaultValue: undefined
	}, props, buildInDefaultProps));
}

/* eslint-disable react/prop-types */
DatePickerField.renderTable = function renderTable(_ref, _ref2) {
	var dateFormat = _ref.dateFormat;
	var value = _ref2.value;

	return React.createElement(
		'span',
		null,
		moment(new Date(value)).format(dateFormat)
	);
};

DatePickerField.propTypes = {
	dateFormat: PropTypes.string
};

DatePickerField.defaultProps = {
	dateFormat: 'YYYY-MM-DD'
};

export default field(DatePickerField);