var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from 'prop-types';
import React, { Component } from 'react';
import hoist, { extractRef } from '../hoist';
import ModalStore from '../../stores/ModalStore';
import ModalStoreContext from './ModalStoreContext';

export default function withModalStoreProvider() {
	return function createModalStoreProviderComponent(WrappedComponent) {
		var _dec, _class, _class2, _temp;

		var WithModalStoreProvider = (_dec = hoist(WrappedComponent), _dec(_class = (_temp = _class2 = function (_Component) {
			_inherits(WithModalStoreProvider, _Component);

			function WithModalStoreProvider(props) {
				_classCallCheck(this, WithModalStoreProvider);

				var _this = _possibleConstructorReturn(this, (WithModalStoreProvider.__proto__ || Object.getPrototypeOf(WithModalStoreProvider)).call(this, props));

				var modalStore = props.modalStore;

				_this.modalStore = new ModalStore(modalStore);
				return _this;
			}

			_createClass(WithModalStoreProvider, [{
				key: 'render',
				value: function render() {
					var modalStore = this.modalStore,
					    props = this.props;

					var _ = props.modalStore,
					    other = _objectWithoutProperties(props, ['modalStore']);

					return React.createElement(
						ModalStoreContext.Provider,
						{ value: modalStore },
						React.createElement(WrappedComponent, _extends({}, extractRef(other), { modalStore: modalStore }))
					);
				}
			}]);

			return WithModalStoreProvider;
		}(Component), _class2.propTypes = {
			modalStore: PropTypes.object
		}, _temp)) || _class);

		return WithModalStoreProvider;
	};
}