import _trim from 'lodash/trim';
import _isArray from 'lodash/isArray';
import _isString from 'lodash/isString';

import { isObservableArray } from 'mobx';

export default function ensureFileList() {
	var fileList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

	if (_isString(fileList)) {
		fileList = fileList.split(',');
	}

	if (!_isArray(fileList) && !isObservableArray(fileList)) {
		throw new Error('`fileList` must be a string or array');
	}

	return fileList.map(_trim).filter(Boolean).map(function (url, index) {
		return {
			uid: -index,
			url: url,
			name: url
		};
	});
}