import _isArray from 'lodash/isArray';
import _isString from 'lodash/isString';
import { isObservableArray } from 'mobx';

import warning from 'warning';

export default function joinKeys(keys) {
	var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'CSV';

	if (!keys) return '';
	if (_isString(keys)) return keys;

	if (type === 'CSV') {
		if (_isArray(keys) || isObservableArray(keys)) {
			return keys.join(',');
		}
	} else {
		process.env.NODE_ENV !== 'production' ? warning(false, 'Joining keys with "' + type + '" is not supported') : void 0;
	}

	return '';
}