'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _withModalStore = require('../../hocs/withModalStore');

var _withModalStore2 = _interopRequireDefault(_withModalStore);

var _withIssuer = require('../../hocs/withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _Issuers = require('../../utils/Issuers');

var _ModalProvider = require('../ModalProvider');

var _ModalProvider2 = _interopRequireDefault(_ModalProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ModalConsumer = (_dec = (0, _withIssuer2.default)({ issuer: _Issuers.MODAL }), _dec2 = (0, _withModalStore2.default)(), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
	_inherits(ModalConsumer, _Component);

	function ModalConsumer(props) {
		_classCallCheck(this, ModalConsumer);

		var _this = _possibleConstructorReturn(this, (ModalConsumer.__proto__ || Object.getPrototypeOf(ModalConsumer)).call(this, props));

		_this.close = function () {
			_this.props.modalStore.close();
		};

		var children = props.children,
		    modalStore = props.modalStore,
		    other = _objectWithoutProperties(props, ['children', 'modalStore']);

		modalStore.setModalProps(other);
		return _this;
	}

	_createClass(ModalConsumer, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.props.modalStore.setModalProps({});
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    modalStore = _props.modalStore,
			    children = _props.children;

			return _react2.default.createElement(
				_ModalProvider2.default,
				{ modalStore: modalStore },
				children
			);
		}
	}]);

	return ModalConsumer;
}(_react.Component), _class2.propTypes = {
	children: _propTypes2.default.node,
	modalStore: _propTypes2.default.object.isRequired
}, _temp)) || _class) || _class) || _class);
exports.default = ModalConsumer;