'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _style2 = require('antd/lib/modal/style');

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _mobxReact = require('mobx-react');

var _withModalStore = require('../../hocs/withModalStore');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ModalProvider = (_dec = (0, _withModalStore.withModalStoreProvider)(), _dec(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(ModalProvider, _Component);

	function ModalProvider() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, ModalProvider);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ModalProvider.__proto__ || Object.getPrototypeOf(ModalProvider)).call.apply(_ref, [this].concat(args))), _this), _this._handleOk = function (ev) {
			var modalProps = _this.props.modalStore.modalProps;

			if (modalProps.onOk) modalProps.onOk(ev);
			ev.isDefaultPrevented() || _this._close();
		}, _this._handleCancel = function (ev) {
			var modalProps = _this.props.modalStore.modalProps;

			if (modalProps.onCancel) modalProps.onCancel(ev);
			ev.isDefaultPrevented() || _this._close();
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(ModalProvider, [{
		key: '_close',
		value: function _close() {
			this.props.modalStore.close();
		}
	}, {
		key: 'render',
		value: function render() {
			var modals = this.context.appConfig.modals,
			    _props = this.props,
			    modalStore = _props.modalStore,
			    children = _props.children,
			    Wrap = _props.component,
			    other = _objectWithoutProperties(_props, ['modalStore', 'children', 'component']);

			var visible = modalStore.visible,
			    modalProps = modalStore.modalProps,
			    state = modalStore.state,
			    name = modalStore.name;

			var Comp = modals.get(name);
			return _react2.default.createElement(
				Wrap,
				other,
				children,
				_react2.default.createElement(
					_modal2.default,
					_extends({
						maskClosable: false
					}, modalProps, {
						visible: visible,
						onOk: this._handleOk,
						onCancel: this._handleCancel
					}),
					visible && _react2.default.createElement(Comp, state)
				)
			);
		}
	}]);

	return ModalProvider;
}(_react.Component), _class2.propTypes = {
	modalStore: _PropTypes2.default.object.isRequired,
	children: _PropTypes2.default.node,
	component: _PropTypes2.default.component
}, _class2.defaultProps = {
	component: 'div'
}, _class2.contextTypes = {
	appConfig: _PropTypes2.default.object.isRequired
}, _temp2)) || _class) || _class);
exports.default = ModalProvider;