'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _style2 = require('antd/lib/message/style');

var _message = require('antd/lib/message');

var _message2 = _interopRequireDefault(_message);

var _isFunction2 = require('lodash/isFunction');

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = createFormDetailView;

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPolyfill = require('../../utils/reactPolyfill');

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _mobxReact = require('mobx-react');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _routerStore = require('../../stores/routerStore');

var _routerStore2 = _interopRequireDefault(_routerStore);

var _withTable = require('../../hocs/withTable');

var _withTable2 = _interopRequireDefault(_withTable);

var _withIssuer = require('../../hocs/withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _withStore = require('../../hocs/withStore');

var _withStore2 = _interopRequireDefault(_withStore);

var _Form = require('../../components/Form');

var _FormBody = require('../../components/FormBody');

var _FormBody2 = _interopRequireDefault(_FormBody);

var _joinKeys = require('../../utils/joinKeys');

var _joinKeys2 = _interopRequireDefault(_joinKeys);

var _Issuers = require('../../utils/Issuers');

var _ModalProvider = require('../../components/ModalProvider');

var _ModalProvider2 = _interopRequireDefault(_ModalProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function createFormDetailView(title, issuer, displayName) {
	var _dec, _dec2, _dec3, _class, _class2, _temp, _initialiseProps;

	var isCreater = issuer === _Issuers.CREATER;

	var FormDetailView = (_dec = (0, _withIssuer2.default)({ issuer: issuer }), _dec2 = (0, _withTable2.default)({ syncLocation: true, type: 'detail' }), _dec3 = (0, _withStore2.default)(), _dec(_class = _dec2(_class = _dec3(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
		_inherits(FormDetailView, _Component);

		function FormDetailView(props) {
			_classCallCheck(this, FormDetailView);

			var _this = _possibleConstructorReturn(this, (FormDetailView.__proto__ || Object.getPrototypeOf(FormDetailView)).call(this, props));

			_initialiseProps.call(_this);

			var store = props.store,
			    match = props.match;

			var selectedKeys = (match.params.key || '').split(',');
			if (isCreater) {
				_this._createrValue = {};
			} else {
				store.setSelectedKeys(selectedKeys);
				store.call('fetch');
			}
			return _this;
		}

		_createClass(FormDetailView, [{
			key: '_redirectToUpdate',
			value: function _redirectToUpdate(store, responseData) {
				var _routerStore$location = _routerStore2.default.location,
				    pathname = _routerStore$location.pathname,
				    search = _routerStore$location.search;
				var uniqueKey = store.config.uniqueKey;

				if (uniqueKey && responseData && responseData[uniqueKey]) {
					var key = responseData[uniqueKey];
					var newPathname = pathname.replace(/create$/, 'update/' + key);
					var path = newPathname + search;
					_routerStore2.default.replace(path);
				}
			}
		}, {
			key: 'render',
			value: function render() {
				var _props = this.props,
				    store = _props.store,
				    Header = _props.header,
				    Footer = _props.footer,
				    _state = this.state,
				    isValid = _state.isValid,
				    isSubmitting = _state.isSubmitting,
				    isPristine = _state.isPristine;

				return _react2.default.createElement(
					_ModalProvider2.default,
					null,
					_react2.default.createElement(
						'div',
						{ style: _styles2.default.container },
						Header ? _react2.default.createElement(Header, { title: title, store: store }) : _react2.default.createElement(
							'h1',
							null,
							title
						),
						_react2.default.createElement(_FormBody2.default, {
							ref: this.formRef,
							value: isCreater ? this._createrValue : store.getData(),
							store: store,
							onSubmit: this._handleSubmit,
							onChange: this._handleChange,
							onValidChange: this._handleValidChange,
							layout: 'vertical',
							footer: _react2.default.createElement(
								_Form.Submit,
								{
									disabled: isPristine || !isValid || isSubmitting,
									type: 'primary',
									size: 'large',
									loading: isSubmitting
								},
								'Save'
							)
						}),
						Footer && _react2.default.createElement(Footer, { store: store })
					)
				);
			}
		}]);

		return FormDetailView;
	}(_react.Component), _class2.displayName = displayName, _class2.propTypes = {
		match: _PropTypes2.default.object.isRequired,
		store: _PropTypes2.default.object.isRequired,
		save: _PropTypes2.default.stringOrFunc,
		title: _PropTypes2.default.node,
		header: _PropTypes2.default.component,
		footer: _PropTypes2.default.component
	}, _class2.defaultProps = {
		title: title,
		save: isCreater ? 'create' : 'update'
	}, _initialiseProps = function _initialiseProps() {
		var _this2 = this;

		this.state = {
			isValid: true,
			isSubmitting: false,
			isPristine: true
		};
		this.formRef = (0, _reactPolyfill.createRef)();

		this._handleChange = function () {
			if (_this2.state.isPristine) {
				_this2.setState({ isPristine: false });
			}
		};

		this._handleValidChange = function (isValid) {
			_this2.isValid = isValid;
			_this2.setState({ isValid: isValid });
		};

		this._handleSubmit = function () {
			var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(body) {
				var props, match, save, store, selectedKeys, url, reqParams, responseData;
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_this2.setState({ isSubmitting: true });
								props = _this2.props;
								match = props.match, save = props.save, store = props.store;
								selectedKeys = (match.params.key || '').split(',');
								url = (0, _joinKeys2.default)(selectedKeys);
								_context.prev = 5;
								reqParams = _extends({}, props, {
									url: url,
									body: body,
									refresh: false,
									throwError: true
								});

								if (!(0, _isFunction3.default)(save)) {
									_context.next = 13;
									break;
								}

								_context.next = 10;
								return save(reqParams);

							case 10:
								_context.t0 = _context.sent;
								_context.next = 16;
								break;

							case 13:
								_context.next = 15;
								return store.call(save, reqParams);

							case 15:
								_context.t0 = _context.sent;

							case 16:
								responseData = _context.t0;

								_this2.setState({ isSubmitting: false, isPristine: true });

								// TODO: should add locale support
								_message2.default.info('Success!');

								if (isCreater) {
									_this2._redirectToUpdate(store, responseData);
								}
								_context.next = 27;
								break;

							case 22:
								_context.prev = 22;
								_context.t1 = _context['catch'](5);

								_this2.setState({ isSubmitting: false });
								_message2.default.error('Failed!');
								process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(false, _context.t1.message) : void 0;

							case 27:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, _this2, [[5, 22]]);
			}));

			return function (_x) {
				return _ref.apply(this, arguments);
			};
		}();
	}, _temp)) || _class) || _class) || _class) || _class);


	return FormDetailView;
}