'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _isFunction2 = require('lodash/isFunction');

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _isObject2 = require('lodash/isObject');

var _isObject3 = _interopRequireDefault(_isObject2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Form = require('../../components/Form');

var _field = require('../../hocs/field');

var _field2 = _interopRequireDefault(_field);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildInDefaultProps = {
	inputFilter: function inputFilter(val) {
		if (!val) {} else if ((0, _isObject3.default)(val)) {
			return val;
		} else if ((0, _isString3.default)(val)) {
			return (0, _moment2.default)(val);
		}
	},
	outputFilter: function outputFilter(val) {
		if (!val) {} else if ((0, _isFunction3.default)(val.toISOString)) {
			return val.toISOString();
		} else if ((0, _isString3.default)(val)) {
			return val;
		}
	}
};

function DatePickerField(props) {
	return _react2.default.createElement(_Form.DatePicker, _extends({
		format: 'date',
		defaultValue: undefined
	}, props, buildInDefaultProps));
}

/* eslint-disable react/prop-types */
DatePickerField.renderTable = function renderTable(_ref, _ref2) {
	var dateFormat = _ref.dateFormat;
	var value = _ref2.value;

	return _react2.default.createElement(
		'span',
		null,
		(0, _moment2.default)(new Date(value)).format(dateFormat)
	);
};

DatePickerField.propTypes = {
	dateFormat: _propTypes2.default.string
};

DatePickerField.defaultProps = {
	dateFormat: 'YYYY-MM-DD'
};

exports.default = (0, _field2.default)(DatePickerField);