'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _mobx = require('mobx');

var _getRequest = require('../utils/getRequest');

var _getRequest2 = _interopRequireDefault(_getRequest);

var _DataListStore = require('./DataListStore');

var _DataListStore2 = _interopRequireDefault(_DataListStore);

var _DataDetailStore = require('./DataDetailStore');

var _DataDetailStore2 = _interopRequireDefault(_DataDetailStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DispatcherStore = function () {
	function DispatcherStore() {
		_classCallCheck(this, DispatcherStore);
	}

	_createClass(DispatcherStore, [{
		key: 'init',
		value: function init(appConfig, authStore) {
			this.appConfig = appConfig;
			this.authStore = authStore;
			this.baseRequest = (0, _getRequest2.default)(appConfig);
			this.stores = {
				list: _mobx.observable.map(),
				detail: _mobx.observable.map()
			};
		}
	}, {
		key: 'ensureStore',
		value: function ensureStore(name) {
			var _this = this;

			var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
			var _options$type = options.type,
			    type = _options$type === undefined ? 'list' : _options$type,
			    config = options.config,
			    useCache = options.useCache,
			    router = options.router;


			var createStore = function createStore() {
				var appConfig = _this.appConfig,
				    authStore = _this.authStore,
				    baseRequest = _this.baseRequest;

				var Store = type === 'list' ? _DataListStore2.default : _DataDetailStore2.default;
				return new Store({
					name: name,
					appConfig: appConfig,
					authStore: authStore,
					baseRequest: baseRequest,
					config: config,
					router: router
				});
			};

			if (!~['list', 'detail'].indexOf(type)) {
				throw new Error('Only type "list" or "detail" is valid, but received "' + type + '"');
			}
			var stores = this.stores[type];
			if (useCache) {
				if (stores.has(name)) {
					var store = stores.get(name);
					store.mount();
					return store;
				} else {
					var _store = createStore();
					stores.set(name, _store);
					return _store;
				}
			} else {
				return createStore();
			}
		}
	}]);

	return DispatcherStore;
}();

exports.default = new DispatcherStore();