'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _defaults2 = require('lodash/defaults');

var _defaults3 = _interopRequireDefault(_defaults2);

var _cookie = require('cookie');

var _cookie2 = _interopRequireDefault(_cookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
	set: function set(name, value) {
		var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

		(0, _defaults3.default)(options, { path: '/' });
		return document.cookie = _cookie2.default.serialize(name, value, options);
	},
	get: function get(name) {
		return _cookie2.default.parse(document.cookie)[name];
	},
	remove: function remove(name) {
		var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

		options = (0, _defaults3.default)(options, { path: '/' });
		options.expires = new Date(0);
		return !!(document.cookie = _cookie2.default.serialize(name, '', options));
	}
};