'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _trim2 = require('lodash/trim');

var _trim3 = _interopRequireDefault(_trim2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

exports.default = ensureFileList;

var _mobx = require('mobx');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ensureFileList() {
	var fileList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

	if ((0, _isString3.default)(fileList)) {
		fileList = fileList.split(',');
	}

	if (!(0, _isArray3.default)(fileList) && !(0, _mobx.isObservableArray)(fileList)) {
		throw new Error('`fileList` must be a string or array');
	}

	return fileList.map(_trim3.default).filter(Boolean).map(function (url, index) {
		return {
			uid: -index,
			url: url,
			name: url
		};
	});
}