'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _isObject2 = require('lodash/isObject');

var _isObject3 = _interopRequireDefault(_isObject2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = parseAPIPath;

var _tinyQuerystring = require('tiny-querystring');

var _history = require('history');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseAPIPath(apiPath) {
	if ((0, _isString3.default)(apiPath)) {
		apiPath = (0, _history.parsePath)(apiPath);
		apiPath.query = apiPath.search.slice(1);
	}

	if ((0, _isObject3.default)(apiPath)) {
		if ((0, _isString3.default)(apiPath.query)) {
			apiPath.query = (0, _tinyQuerystring.parse)(apiPath.query);
		}

		if (apiPath.query === null) {
			apiPath.query = {};
		}

		return _extends({
			pathname: '/',
			query: {},
			headers: {}
		}, apiPath);
	}

	throw new Error('`apiPath` should be string or object, but received', typeof apiPath === 'undefined' ? 'undefined' : _typeof(apiPath));
}